'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (steps) {
  var configAsyncSteps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _config2.default.cwdPackage.asyncsteps || {};

  var vars = new _Vars2.default();
  var events = new _Events2.default();
  var modular = createModular(configAsyncSteps.pathsToModules);
  var middleware = createMiddleware();

  return new _AsyncStepsEngine2.default(steps, vars, modular, middleware, events);
};

var _asyncSteps = require('async-steps.engine');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _AsyncStepsEngine = require('./lib/AsyncStepsEngine');

var _AsyncStepsEngine2 = _interopRequireDefault(_AsyncStepsEngine);

var _Modular = require('./lib/Modular');

var _Modular2 = _interopRequireDefault(_Modular);

var _Vars = require('./lib/Vars');

var _Vars2 = _interopRequireDefault(_Vars);

var _Events = require('./lib/Events');

var _Events2 = _interopRequireDefault(_Events);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _dataSet = require('./middlewares/dataSet');

var _dataSet2 = _interopRequireDefault(_dataSet);

var _timeout = require('./middlewares/timeout');

var _timeout2 = _interopRequireDefault(_timeout);

var _module2 = require('./middlewares/module');

var _module3 = _interopRequireDefault(_module2);

var _after = require('./middlewares/after');

var _after2 = _interopRequireDefault(_after);

var _dataGet = require('./middlewares/dataGet');

var _dataGet2 = _interopRequireDefault(_dataGet);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = require('debug')('async-steps:index');

function createModular() {
  var pathsToModules = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  var modular = new _Modular2.default();

  var PATHSTOMODULES = pathsToModules.map(function (folderModules) {
    return Object.assign({}, folderModules, {
      path: folderModules.homeDir ? _path2.default.join(_config2.default.cwdDir, folderModules.path) : folderModules.path
    });
  });

  var _loop = function _loop(i) {
    var MODULES = require(PATHSTOMODULES[i].path).default;
    var PREFIX = PATHSTOMODULES[i].prefix;

    MODULES.forEach(function (module) {
      modular.add(module.name, module.fn, PREFIX);
    });
  };

  for (var i = 0; i < PATHSTOMODULES.length; i++) {
    _loop(i);
  }

  return modular;
}

function createMiddleware() {
  var middleware = new _asyncSteps.Middleware();

  middleware.use(_dataSet2.default);
  middleware.use(_timeout2.default);
  middleware.use(_module3.default);
  middleware.use(_after2.default);
  middleware.use(_dataGet2.default);

  return middleware;
}