'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = require('debug')('async-steps:Modular');

var Modular = function () {
  function Modular() {
    (0, _classCallCheck3.default)(this, Modular);

    this._modules = {
      'default': {}
    };
  }

  /**
   * Возвращает модули
   *
   * @return {object}
   */


  (0, _createClass3.default)(Modular, [{
    key: 'add',


    /**
     * Добавляет модуль
     *
     * @param {string} name - имя модуля
     * @param {function} fn
     * @param {string} [prefix=default] - префикс имени
     */
    value: function add(name, fn) {
      var prefix = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'default';

      if (this.check(name, prefix)) {
        throw new Error('module "' + prefix + '/' + name + '" is exist');
      }

      if (typeof fn !== 'function') {
        throw new TypeError('"fn" is not a function');
      }

      this._modules[prefix] = this._modules[prefix] || {};
      this._modules[prefix][name] = fn;
      debug('set module "' + prefix + '/' + name + '"');
    }

    /**
     * Проверяет наличие модуля
     *
     * @param {string} name - имя модуля
     * @param {string} [prefix=default] - префикс имени
     * @return {boolean}
     */

  }, {
    key: 'check',
    value: function check(name) {
      var prefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'default';

      return this._modules[prefix] && this._modules[prefix][name];
    }

    /**
     * Метод запускает модуль
     *
     * @param {string} name - имя модуля
     * @param {string} [prefix=default] - префикс имени
     * @param {object} params - параметры модуля
     * @param {*} [data] - данные
     * @param namespace - экземпляр класса Namespace
     * @return {Promise}
     */

  }, {
    key: 'start',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(name) {
        var prefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'default';
        var params = arguments[2];
        var data = arguments[3];
        var namespace = arguments[4];
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (this.check(name, prefix)) {
                  _context.next = 2;
                  break;
                }

                throw new Error('module "' + prefix + '/' + name + '" of undefined');

              case 2:
                _context.prev = 2;
                _context.next = 5;
                return this._modules[prefix][name](params, data, namespace);

              case 5:
                return _context.abrupt('return', _context.sent);

              case 8:
                _context.prev = 8;
                _context.t0 = _context['catch'](2);
                throw _context.t0;

              case 11:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[2, 8]]);
      }));

      function start(_x3) {
        return _ref.apply(this, arguments);
      }

      return start;
    }()
  }, {
    key: 'modules',
    get: function get() {
      return this._modules;
    }
  }]);
  return Modular;
}();

exports.default = Modular;